package com.xinelu.manage.mapper.wechattemplate;

import com.xinelu.manage.domain.wechattemplate.WechatTemplate;
import com.xinelu.manage.domain.wechattemplatesuittask.WechatTemplateSuitTask;
import com.xinelu.manage.dto.wechattemplate.WechatTemplateDTO;
import com.xinelu.manage.dto.wechattemplate.WechatTemplateTaskDTO;
import com.xinelu.manage.vo.wechattemplate.WechatTemplateTaskVO;
import com.xinelu.manage.vo.wechattemplate.WechatTemplateVO;
import java.util.List;
import org.apache.ibatis.annotations.Param;

/**
 * 微信模板信息Mapper接口
 *
 * @author xinelu
 * @date 2024-02-27
 */
public interface WechatTemplateMapper {
    /**
     * 查询微信模板信息
     *
     * @param id 微信模板信息主键
     * @return 微信模板信息
     */
    public WechatTemplate selectWechatTemplateById(Long id);

    /**
     * 查询微信模板信息列表
     *
     * @param wechatTemplate 微信模板信息
     * @return 微信模板信息集合
     */
    public List<WechatTemplate> selectWechatTemplateList(WechatTemplate wechatTemplate);

    /**
     * 新增微信模板信息
     *
     * @param wechatTemplate 微信模板信息
     * @return 结果
     */
    public int insertWechatTemplate(WechatTemplate wechatTemplate);

    /**
     * 修改微信模板信息
     *
     * @param wechatTemplate 微信模板信息
     * @return 结果
     */
    public int updateWechatTemplate(WechatTemplate wechatTemplate);

    /**
     * 删除微信模板信息
     *
     * @param id 微信模板信息主键
     * @return 结果
     */
    public int deleteWechatTemplateById(Long id);

    /**
     * 批量删除微信模板信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteWechatTemplateByIds(Long[] ids);

    /**
     * 查询微信模板信息Dto列表
     */
    List<WechatTemplateTaskVO> selectWechatTemplateDtoList(WechatTemplateDTO wechatTemplateDto);

    /**
     * 根据id查询微信模板Dto
     */
    WechatTemplateVO selectWechatTemplateDtoById(@Param("id") Long id);

    /**
     * 新增微信模板适用任务类型
     */
    int insertWechatTemplateSuitTask(List<WechatTemplateSuitTask> tasks);

    /**
     * 修改微信模板适用任务类型
     */
    int updateWechatTemplateSuitTask(List<WechatTemplateSuitTask> tasks);

    /**
     * 批量删除微信模板使用任务类型
     */
    int deleteWechatTemplateSuitTaskByIds(Long[] ids);

    /**
     * 检查微信模板名称是否存在
     */
    int countByWechatTemplateTaskDTO(WechatTemplateTaskDTO wechatTemplateTaskDTO);

    /**
     * 根据id删除之前存储的适用模板任务类型
     */
    void deleteWechatTemplateSuitTaskById(Long id);

    /**
     * 检查除当前记录之外是否存在同名的微信模板名称
     */
    int countByWechatTemplateNameExcludingId(@Param("id") Long id, @Param("departmentId") Long departmentId, @Param("wechatTemplateName") String wechatTemplateName, @Param("templateSource") String templateSource);
}
